import 'dart:async';

import 'package:analyzer/dart/element/element.dart';
import 'package:b_annotations/b_annotations.dart';
import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';

class BundleGenerator extends GeneratorForAnnotation<BlocAnnotation> {
  @override
  FutureOr<String> generateForAnnotatedElement(Element element, ConstantReader annotation, BuildStep buildStep) {
    final String shortName = element.source.shortName.split('.').first;
    return """
      export '$shortName.dart';  
      export '$shortName.events.dart';  
      export '$shortName.state.dart';  
    """;
  }
}
