
// todo: Generate methods for immutable state

import 'dart:async';

import 'package:analyzer/dart/element/element.dart';
import 'package:b_annotations/b_annotations.dart';
import 'package:b_generator/src/helpers/field_visitor.dart';
import 'package:b_generator/src/helpers/props.dart';
import 'package:b_generator/src/helpers/unnamed_constructor.dart';
import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';

import 'helpers/field_getters.dart';

class StateGenerator extends GeneratorForAnnotation<StateAnnotation> {
	@override
	FutureOr<String> generateForAnnotatedElement(Element element, ConstantReader annotation, BuildStep buildStep) {
		final Set<FieldElement> fields = {};
		element.visitChildren(FieldVisitor((field) => fields.add(field)));

		return """
    abstract class GeneratedState extends Equatable {
      ${fieldGetters(fields)}
      
      ${constructorByString('GeneratedState', fields)}
      
      ${props(fields)}
    }""";
	}
}
